/***************************************************************************
 *   cttask.h                                                              *
 *   --------------------------------------------------------------------  *
 *   CT Task Header                                                        *
 *   --------------------------------------------------------------------  *
 *   Copyright (C) 1999, Gary Meyer <gary@meyer.net>                       *
 *   --------------------------------------------------------------------  *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 ***************************************************************************/

#ifndef CTTASK_H
#define CTTASK_H

// Do not introduce any Qt or KDE dependencies into the "CT"-prefixed classes.
// I want to be able to reuse these classes with another GUI toolkit. -GM 11/99

#include <qstring.h>
#include <qstringlist.h>
#include "ctmonth.h"
#include "ctdom.h"
#include "ctdow.h"
#include "cthour.h"
#include "ctminute.h"
#include <iostream> // istream, ostream

/**
  * A scheduled task (encapsulation of crontab entry).  Encapsulates
  * parsing, tokenization, and natural language description.
  */
class CTTask
{
public:

/**
  * Constructs scheduled task from crontab format QString.
  */
  CTTask(QString& tokStr, QString& _comment,int _first,int _last,bool syscron = false);

//  CTTask(const CTTask& source);




/**
  * Indicates whether or not the task belongs to the system crontab.
  */
  bool system() const;

  
  CTMonth      month;
  CTDayOfMonth dayOfMonth;
  CTDayOfWeek  dayOfWeek;
  CTHour       hour;
  CTMinute     minute;
  QString      s_month;
  QString      s_day;
  QString      s_week;
  QString      s_hour;
  QString      s_minute;
  QString      user;
  QString      command;
  QString      comment;
  bool         enabled;
  bool         check; 
  //  false  ޷ʶ 
  int          first;
  int          last;
 

private:
  bool         syscron;
  bool         range(QString _month,QString _day);
};

#endif // CTTASK_H
